unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, APL_PSS_API_Lib_TLB;

type
  TForm1 = class(TForm)
    AplPssAPI1: TAplPssAPI;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
PssApi     :IAplAPI;
PssData    :IAplAPI_Data;
PssFolder  :IAplAPI_Folder;
PssCateg   :IAplAPI_Category;
PssDoc     :IAplAPI_Document;
PssProduct :IAplAPI_Product;
PssAutoriz :IAplAPI_Autorization;
PssBPoc    :IAplAPI_BProcess;
PssCharact :IAplAPI_Characteristic;

inst : Integer;
categ : Integer;

begin
  //    
  PssApi     := AplPssAPI1.DefaultInterface;
  PssData    := PssApi As IAplAPI_Data;
  PssFolder  := PssApi As IAplAPI_Folder;
  PssCateg   := PssApi As IAplAPI_Category;
  PssDoc     := PssApi As IAplAPI_Document;
  PssProduct := PssApi As IAplAPI_Product;
  PssAutoriz := PssApi As IAplAPI_Autorization;
  PssBPoc    := PssApi As IAplAPI_BProcess;
  PssCharact := PssApi As IAplAPI_Characteristic;

  PssApi.Connect('','','');  //     
  //  ,    
  inst:=PssApi.SelectInstance(1+2+8,0,' ');

  if(inst=0) then ShowMessage('  ')
  else if(PssData.IsKindOfBN(inst,'apl_folder')) then
    begin
      ShowMessage(' ');
      //     'AAA'  
      PssFolder.CreateFolder(inst,'AAA','');
    end
  else if(PssData.IsKindOfBN(inst,'product_category')) then
    begin
      ShowMessage(' ');
      //     'AAA'   ''
      categ := PssCateg.CreateCategory('AAA','','');
      //    
      PssCateg.InsertSubCategory(inst,categ);
    end
  else if(PssData.IsKindOfBN(inst,'product_definition_formation')) then
    begin
      ShowMessage('  ');
    end;

  PssApi.SaveChanges(); //  
  PssApi.Disconnect();  //  

end;

procedure TForm1.Button2Click(Sender: TObject);
var

  LongMapComponent :CoAplLongMap;
  StrMapComponent  :CoAplStringMap;
  longmap1 : AplLongMap;
  longmap2 : AplLongMap;
  strmap : AplStringMap;
  k : integer;
  s : string;

begin
  //    Long->Long
  longmap1:=LongMapComponent.Create();
  longmap2:=LongMapComponent.Create();

  //   

  longmap1.Add(3,6);
  longmap1.Add(4,8);
  longmap1.Add(5,10);
  longmap1.Add(6,12);

  longmap2.Add(1,2);
  longmap2.Add(2,4);

  //      

  k:=longmap2.GetByKeyP(3);
  Str(k,s);
  ShowMessage(s);

  k:=longmap2.GetByKeyP(2);
  Str(k,s);
  ShowMessage(s);

  k:=longmap2.GetByKeyP(1);
  Str(k,s);
  ShowMessage(s);

  //   String->Long

  strmap := CoAplStringMap.Create();

  //  

  strmap.Add('alfa',1);
  strmap.Add('gamma',3);
  strmap.Add('betta',2);

  //      

  k:=strmap.GetByKeyP('');
  Str(k,s);
  ShowMessage(s);

  k:=strmap.GetByKeyP('alfa');
  Str(k,s);
  ShowMessage(s);

  k:=strmap.GetByKeyP('gamma');
  Str(k,s);
  ShowMessage(s);
end;

procedure TForm1.Button3Click(Sender: TObject);
var

  //        
  //     
  PssApi     :IAplAPI;
  PssData    :IAplAPI_Data;
  PssFolder  :IAplAPI_Folder;
  PssCateg   :IAplAPI_Category;
  PssDoc     :IAplAPI_Document;
  PssProduct :IAplAPI_Product;
  PssAutoriz :IAplAPI_Autorization;
  PssBPoc    :IAplAPI_BProcess;
  PssCharact :IAplAPI_Characteristic;

  find_folder:String;
  err,s:WideString;

  ext: OleVariant;
  arr: array of Integer;
  k:Integer;

  inst_folder,inst_pdf,inst_prd: Integer;
  v : Variant;

begin

  //    
  //           
  PssApi     := AplPssAPI1.DefaultInterface;
  PssData    := PssApi As IAplAPI_Data;
  PssFolder  := PssApi As IAplAPI_Folder;
  PssCateg   := PssApi As IAplAPI_Category;
  PssDoc     := PssApi As IAplAPI_Document;
  PssProduct := PssApi As IAplAPI_Product;
  PssAutoriz := PssApi As IAplAPI_Autorization;
  PssBPoc    := PssApi As IAplAPI_BProcess;
  PssCharact := PssApi As IAplAPI_Characteristic;

  PssApi.Connect('','','');  //     

    //   ""

    //  
     find_folder:=
        'SELECT '+
        'Ext_ '+
        'FROM '+
        'Ext_{apl_folder.name  = '''' } '+
        'END_SELECT';

      //  
      PssApi.QueryExecute(find_folder,err,ext,0);

      //    
       k:=VarArrayHighBound(ext,1)-VarArrayLowBound(ext,1)+1;

      if(k<=0) then begin
        ShowMessage(' ""   !');
        PssApi.Disconnect();
        Exit;
        end;

      if(k>1) then begin
        ShowMessage('  ""   .    !');
        PssApi.Disconnect();
        Exit;
        end;

      //    ( )
      Str(k,s);
      ShowMessage(s);

      arr:=ext;
      inst_folder:=arr[0];
      inst_pdf:=0;


      //         '1234'
      inst_prd:= PssProduct.FindProductByID('1234');
      //  ,   
      if (inst_prd<>0)  then inst_pdf := PssProduct.FindPdfByID(inst_prd ,'');
      //   ,
      if (inst_pdf=0) then begin

        //      
        inst_pdf := PssProduct.CreatePDF('1234','','',0);
        //   
        PssData.PutAttrBN(inst_pdf,'formation_type','kit');
        //   
        PssData.PutAttrBN(inst_pdf,'make_or_buy','made');
        end;
      //       
      PssFolder.AddToFolder(inst_folder, inst_pdf);

     inst_pdf:=0;

     //         '5678'
     inst_prd:= PssProduct.FindProductByID('5678');
     //  
     if (inst_prd=0)  then begin
          //     

          //  
          inst_prd:=PssData.CreateInstance('product');
          //    
          PssData.PutAttrBN(inst_prd,'id','5678');
           //    
          PssData.PutAttrBN(inst_prd,'name','');
          end;

       //           ' 1'
       inst_pdf := PssProduct.FindPdfByID(inst_prd ,' 1');
       //   
       if (inst_pdf=0) then  begin

          //      

          //  
          inst_pdf:=PssData.CreateInstance('apl_product_definition_formation');
          //    
          PssData.PutAttrBN(inst_pdf,'of_product',inst_prd);
          //     ()
          PssData.PutAttrBN(inst_pdf,'id',' 1');
          //   
          PssData.PutAttrBN(inst_pdf,'formation_type','kit');
          //   
          PssData.PutAttrBN(inst_pdf,'make_or_buy','made');
          end;

         //       
        PssFolder.AddToFolder(inst_folder, inst_pdf);


  PssApi.SaveChanges(); //  
  PssApi.Disconnect();  //  

end;

procedure TForm1.Button4Click(Sender: TObject);
var
  //        
  //     
  PssApi     :IAplAPI;
  PssData    :IAplAPI_Data;
  PssFolder  :IAplAPI_Folder;
  PssCateg   :IAplAPI_Category;
  PssDoc     :IAplAPI_Document;
  PssProduct :IAplAPI_Product;
  PssAutoriz :IAplAPI_Autorization;
  PssBPoc    :IAplAPI_BProcess;
  PssCharact :IAplAPI_Characteristic;

  find_folder:String;
  err,s:WideString;

  ext: OleVariant;
  arr: array of Integer;
  i,k:Integer;
  v:variant;

  inst, inst_prd, inst_pdf, inst_char : Integer;
  categ : Integer;

  id_Category, id_Category_P : Integer;
  id_Characteristic_M        : Integer;
  id_Characteristic_P        : Integer;
  id_CharacterType_M         : Integer;
  id_CharacterType_P         : Integer;
  id_unit                    : Integer;

begin

  //    
  //           
  PssApi     := AplPssAPI1.DefaultInterface;
  PssData    := PssApi As IAplAPI_Data;
  PssFolder  := PssApi As IAplAPI_Folder;
  PssCateg   := PssApi As IAplAPI_Category;
  PssDoc     := PssApi As IAplAPI_Document;
  PssProduct := PssApi As IAplAPI_Product;
  PssAutoriz := PssApi As IAplAPI_Autorization;
  PssBPoc    := PssApi As IAplAPI_BProcess;
  PssCharact := PssApi As IAplAPI_Characteristic;

  //      
  v:=false;
  PssApi.AutoSave:=v;

  PssApi.Connect('','','');  //     

  if(not PssApi.IsConnected()) then Exit;

     //    '',     ..
     id_Characteristic_M := PssCharact.GetCharacteristicById('');
     //   .
     id_CharacterType_M  := PssCharact.GetCharacteristicType('');

     //   '',     ..
     id_Characteristic_P := PssCharact.GetCharacteristicById('');

     if( id_Characteristic_P=0) then begin
        ShowMessage('   ""');
        PssApi.Disconnect();
        Exit;
        end;

     //   .
     id_CharacterType_P  := PssCharact.GetCharacteristicType('');

     if( id_CharacterType_P=0) then begin
        ShowMessage('    ""');
        PssApi.Disconnect();
        Exit;
        end;



     //   ''.
     id_Category := PssCateg.FindCategory('');

     //    - 
     if(id_Category=0) then id_Category_P:=PssCateg.CreateCategory('','','');

     //   ' -  '.
     id_Category_P := PssCateg.FindCategory(' ');

     //    - 
     if(id_Category_P=0) then id_Category_P:=PssCateg.CreateCategory(' ',' ','');

     //  .
     PssCateg.CheckOut(id_Category);

     for i := 1 to 10 do
         begin
         //     .
         //  .
         inst_prd := PssData.CreateInstance('product');
         PssData.PutAttrBN(inst_prd, 'id',   '1.'+IntToStr(i));
         PssData.PutAttrBN(inst_prd, 'name', '');
         //  .
         inst_pdf := PssData.CreateInstance('apl_product_definition_formation');
         PssData.PutAttrBN(inst_pdf, 'of_product',     inst_prd);
         PssData.PutAttrBN(inst_pdf, 'id',             ' 1');
         PssData.PutAttrBN(inst_pdf, 'formation_type', 'kit');
         PssData.PutAttrBN(inst_pdf, 'make_or_buy',    'made');
         //   ''.
         PssCharact.CreateMeasuredCharacteristic(inst_pdf,
                                                 id_Characteristic_M,
                                                 id_CharacterType_M,
                                                 i,
                                                 0.1,
                                                 0.1);
         //   '' -    ''.

         //   .
         inst_char := PssData.CreateInstance('apl_reference_value');
         //    .
         // ,   .
         PssData.PutAttrBN(inst_char, 'item', inst_pdf);
         //   ''.
         PssData.PutAttrBN(inst_char, 'characteristic', id_Characteristic_P);
         //   ''   .
         id_unit := PssData.GetAttrBN(id_Characteristic_P, 'unit');
         //         .
         PssData.PutAttrBN(inst_char, 'unit', id_unit);
         //   .
         PssData.PutAttrBN(inst_char, 'assignment_type', id_unit);
         //   -    ' '.
         PssData.PutAttrBN(inst_char, 'val', id_Category_P);

         //     ''.
         PssCateg.AddProductToCategory(inst_prd, id_Category);
         end;

     //  .
     PssCateg.CheckIn(id_Category);

     PssApi.SaveChanges(); //  
     PssApi.Disconnect();
     ShowMessage(' .');
end;

end.
